#ifndef __SETASTREE
#define __SETASTREE

#include <iostream>

class setAsTree
{
public:
	setAsTree(int v);
	setAsTree(const setAsTree& set);
	
	virtual ~setAsTree();
	
	setAsTree& operator=(const setAsTree& set);
	
	void insert(int v);	
	setAsTree* remove(int v);
	
	int min() const;    
	int max() const;
	bool contains(int v) const;
	
	int val;
	setAsTree* ltree,* rtree;

	friend std::ostream& operator<<(std::ostream& stream,const setAsTree& set);
	
private:
	void copy(const setAsTree& set);
	void destroy();
};

std::ostream& operator<<(std::ostream& stream,const setAsTree& set);

#endif